controller = Class {}

function controller:init(l, r, f)
   self.left_press = false
   self.right_press = false
   self.fire_press = false
   self.left_key = l
   self.right_key = r
   self.fire_key = f
end

function controller:left_pressed()
   return self.left_press
end

function controller:right_pressed()
   return self.right_press
end

function controller:fire_pressed()
   local fire_press = self.fire_press
   self.fire_press = false
   return fire_press
end

function controller:keypressed(key, code)
   if key == self.left_key then
      self.left_press = true
   end
   if key == self.right_key then
      self.right_press = true
   end
   if key == self.fire_key then
      self.fire_press = true
   end
end

function controller:keyreleased(key, code)
   if key == self.left_key then
      self.left_press = false
   end
   if key == self.right_key then
      self.right_press = false
   end
   if key == self.fire_key then
      self.fire_press = false
   end
end
